/*****************************************************************************
 *  Rohde&Schwarz Instrument Driver Specific Attribute callbacks
 *
 *  WARNING: Do not add to, delete from, or otherwise modify the contents
 *           of this source file. It is generated from DrBase repository.
 *
 *  Built on: 2024-06-13 13:23:25Z
 *****************************************************************************/

#include "rshmc8015.h"

/*****************************************************************************
 *- Repeated Capabilities ---------------------------------------------------*
 *****************************************************************************/

ViInt32 rshmc8015_RsCoreRepCapTableCount = 4;

RsCoreRepCap rshmc8015_RsCoreRepCapTable[4] =
  { /*
    {
      repCapName  ... Repeated capability name, e.g. "Channel"
      identifiers ... Repeated capability identifiers (comma separated values), e.g. "Ch1,Ch2,Ch3"
      cmdValues   ... Command values (comma separated values), e.g. "1,2,3"
    } */
    {
      "Page",
      "Page1,Page2,Page3,Page4",
      "1,2,3,4"
    }, {
      "Cell",
      "Cell1,Cell2,Cell3,Cell4,Cell5,Cell6",
      "1,2,3,4,5,6"
    }, {
      "Limit",
      "Lim1,Lim2,Lim3,Lim4,Lim5,Lim6",
      "1,2,3,4,5,6"
    }, {
      "Channel",
      "CH1",
      "1"
    }
  };

/*****************************************************************************
 *- Range Tables ------------------------------------------------------------*
 *****************************************************************************/

static RsCoreRangeTableDiscreteEntry rshmc8015_rngViewModeEntries[6] =
  {
    { RSHMC8015_VAL_VIEW_MODE_NORMAL, "NORM" },
    { RSHMC8015_VAL_VIEW_MODE_HARMONICS, "HARM" },
    { RSHMC8015_VAL_VIEW_MODE_TRENDCHART, "TREN" },
    { RSHMC8015_VAL_VIEW_MODE_SIGNALS, "SIGN" },
    { RSHMC8015_VAL_VIEW_MODE_STANDARDS, "STAN" },
    { RSHMC8015_VAL_VIEW_MODE_INRUSH, "INR" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngViewMode = { 6, rshmc8015_rngViewModeEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngNormalViewFunctionEntries[39] =
  {
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_EMPTY, "EMP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_P, "P" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_S, "S" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_Q, "Q" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_PF, "LAMB" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_PHI, "PHI" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_FU, "FU" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_FI, "FI" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_UPP, "UPP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_UMP, "UMP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_IPP, "IPP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_IMP, "IMP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_PPP, "PPP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_PMP, "PMP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_URMS, "URMS" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_UAVG, "UAVG" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_IRMS, "IRMS" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_IAVG, "IAVG" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_UTHD, "UTHD" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_ITHD, "ITHD" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_DIN, "DIN" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_AIN, "AIN" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_TIME, "TIME" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_WH, "WH" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_WHP, "WHP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_WHM, "WHM" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_AH, "AH" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_AHP, "AHP" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_AHM, "AHM" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_TEMP, "TEMP1" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_LIM1, "LIM1" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_LIM2, "LIM2" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_LIM3, "LIM3" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_LIM4, "LIM4" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_LIM5, "LIM5" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_LIM6, "LIM6" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_URANGE, "URAN" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_IRANGE, "IRAN" },
    { RSHMC8015_VAL_NORMAL_VIEW_FUNC_FPLL, "FPLL" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngNormalViewFunction = { 39, rshmc8015_rngNormalViewFunctionEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngViewNormalPageSizeEntries[2] =
  {
    { RSHMC8015_VAL_VIEW_PAGE_SIZE_6, "6" },
    { RSHMC8015_VAL_VIEW_PAGE_SIZE_10, "10" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngViewNormalPageSize = { 2, rshmc8015_rngViewNormalPageSizeEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngHarmonicsViewEntries[2] =
  {
    { RSHMC8015_VAL_VIEW_HARM_VIEW_BAR, "BAR" },
    { RSHMC8015_VAL_VIEW_HARM_VIEW_TAB, "TABL" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngHarmonicsView = { 2, rshmc8015_rngHarmonicsViewEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngHarmonicsSourceEntries[3] =
  {
    { RSHMC8015_VAL_VIEW_HARM_SOURCE_VOLTAGE, "VOLT" },
    { RSHMC8015_VAL_VIEW_HARM_SOURCE_CURRENT, "CURR" },
    { RSHMC8015_VAL_VIEW_HARM_SOURCE_BOTH, "BOTH" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngHarmonicsSource = { 3, rshmc8015_rngHarmonicsSourceEntries };

RsCoreRangeTableRanged rshmc8015_rngHarmonicsNumber = { 5, 50, "" };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngHarmonicsScalingEntries[2] =
  {
    { RSHMC8015_VAL_VIEW_HARM_SCALING_ABSOLUTE, "ABS" },
    { RSHMC8015_VAL_VIEW_HARM_SCALING_PERCENT, "PERC" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngHarmonicsScaling = { 2, rshmc8015_rngHarmonicsScalingEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngHarmonicsSubsetEntries[2] =
  {
    { RSHMC8015_VAL_VIEW_HARM_SUBSET_EVEN, "EVEN" },
    { RSHMC8015_VAL_VIEW_HARM_SUBSET_ODD, "ODD" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngHarmonicsSubset = { 2, rshmc8015_rngHarmonicsSubsetEntries };

RsCoreRangeTableRanged rshmc8015_rngActivePage = { 1, 4, "" };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngIntegratorModeEntries[4] =
  {
    { RSHMC8015_VAL_INTEGRATOR_MODE_MANUAL, "MAN" },
    { RSHMC8015_VAL_INTEGRATOR_MODE_DURATION, "DUR" },
    { RSHMC8015_VAL_INTEGRATOR_MODE_SPAN, "SPAN" },
    { RSHMC8015_VAL_INTEGRATOR_MODE_EXTERN, "EXT" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngIntegratorMode = { 4, rshmc8015_rngIntegratorModeEntries };

RsCoreRangeTableRanged rshmc8015_rngIntegratorDuration = { 0.0, 2.15e9, "s" };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngLoggingModeEntries[4] =
  {
    { RSHMC8015_VAL_LOGGING_MODE_UNLIMITED, "UNL" },
    { RSHMC8015_VAL_LOGGING_MODE_COUNT, "COUN" },
    { RSHMC8015_VAL_LOGGING_MODE_TIME, "DUR" },
    { RSHMC8015_VAL_LOGGING_MODE_SPAN, "SPAN" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngLoggingMode = { 4, rshmc8015_rngLoggingModeEntries };

RsCoreRangeTableRanged rshmc8015_rngLoggingTime = { 1.0, 6.05e5, "s" };

RsCoreRangeTableRanged rshmc8015_rngLoggingCount = { 1, 2147483647, "" };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngLimitSourceEntries[14] =
  {
    { RSHMC8015_VAL_LIMIT_SOURCE_URMS, "URMS" },
    { RSHMC8015_VAL_LIMIT_SOURCE_UAVG, "UAVG" },
    { RSHMC8015_VAL_LIMIT_SOURCE_FU, "FU" },
    { RSHMC8015_VAL_LIMIT_SOURCE_IRMS, "IRMS" },
    { RSHMC8015_VAL_LIMIT_SOURCE_IAVG, "IAVG" },
    { RSHMC8015_VAL_LIMIT_SOURCE_FI, "FI" },
    { RSHMC8015_VAL_LIMIT_SOURCE_P, "P" },
    { RSHMC8015_VAL_LIMIT_SOURCE_S, "S" },
    { RSHMC8015_VAL_LIMIT_SOURCE_Q, "Q" },
    { RSHMC8015_VAL_LIMIT_SOURCE_PF, "LAMB" },
    { RSHMC8015_VAL_LIMIT_SOURCE_PHI, "PHI" },
    { RSHMC8015_VAL_LIMIT_SOURCE_FPLL, "FPLL" },
    { RSHMC8015_VAL_LIMIT_SOURCE_UTHD, "UTHD" },
    { RSHMC8015_VAL_LIMIT_SOURCE_ITHD, "ITHD" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngLimitSource = { 14, rshmc8015_rngLimitSourceEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngAcquisitionModeEntries[3] =
  {
    { RSHMC8015_VAL_ACQ_MODE_AC, "AC" },
    { RSHMC8015_VAL_ACQ_MODE_DC, "DC" },
    { RSHMC8015_VAL_ACQ_MODE_EXTERN, "EXT" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngAcquisitionMode = { 3, rshmc8015_rngAcquisitionModeEntries };

RsCoreRangeTableRanged rshmc8015_rngAcquisitionVoltageRange = { 5.0, 6.0e2, "" };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngAcquisitionCrestFactorEntries[2] =
  {
    { RSHMC8015_VAL_CREST_FACTOR_3, "3" },
    { RSHMC8015_VAL_CREST_FACTOR_6, "6" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngAcquisitionCrestFactor = { 2, rshmc8015_rngAcquisitionCrestFactorEntries };

RsCoreRangeTableRanged rshmc8015_rngAcquisitionCurrentRange = { 5.0e-3, 2.0e1, "" };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngPLLSourceEntries[2] =
  {
    { RSHMC8015_VAL_PLL_SOURCE_VOLTAGE, "VOLT" },
    { RSHMC8015_VAL_PLL_SOURCE_CURRENT, "CURR" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngPLLSource = { 2, rshmc8015_rngPLLSourceEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngImageFormatEntries[2] =
  {
    { RSHMC8015_VAL_IMAGE_FORMAT_BMP, "BMP" },
    { RSHMC8015_VAL_IMAGE_FORMAT_PNG, "PNG" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngImageFormat = { 2, rshmc8015_rngImageFormatEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngAnalogOutputModeEntries[9] =
  {
    { RSHMC8015_VAL_AOUT_MODE_VOLTAGE, "VOLT" },
    { RSHMC8015_VAL_AOUT_MODE_CURRENT, "CURR" },
    { RSHMC8015_VAL_AOUT_MODE_POWER, "POW" },
    { RSHMC8015_VAL_AOUT_MODE_LIM1, "LIM1" },
    { RSHMC8015_VAL_AOUT_MODE_LIM2, "LIM2" },
    { RSHMC8015_VAL_AOUT_MODE_LIM3, "LIM3" },
    { RSHMC8015_VAL_AOUT_MODE_LIM4, "LIM4" },
    { RSHMC8015_VAL_AOUT_MODE_LIM5, "LIM5" },
    { RSHMC8015_VAL_AOUT_MODE_LIM6, "LIM6" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngAnalogOutputMode = { 9, rshmc8015_rngAnalogOutputModeEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngDigitalInputModeEntries[5] =
  {
    { RSHMC8015_VAL_DINP_MODE_FREQUENCY, "FREQ" },
    { RSHMC8015_VAL_DINP_MODE_PWM, "PWM" },
    { RSHMC8015_VAL_DINP_MODE_STATE, "STAT" },
    { RSHMC8015_VAL_DINP_MODE_COMM, "COMM" },
    { RSHMC8015_VAL_DINP_MODE_INT, "INT" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngDigitalInputMode = { 5, rshmc8015_rngDigitalInputModeEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngDigitalOutputModeEntries[8] =
  {
    { RSHMC8015_VAL_DOUT_MODE_FPLL, "FPLL" },
    { RSHMC8015_VAL_DOUT_MODE_COMM, "COMM" },
    { RSHMC8015_VAL_DOUT_MODE_LIM1, "LIM1" },
    { RSHMC8015_VAL_DOUT_MODE_LIM2, "LIM2" },
    { RSHMC8015_VAL_DOUT_MODE_LIM3, "LIM3" },
    { RSHMC8015_VAL_DOUT_MODE_LIM4, "LIM4" },
    { RSHMC8015_VAL_DOUT_MODE_LIM5, "LIM5" },
    { RSHMC8015_VAL_DOUT_MODE_LIM6, "LIM6" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngDigitalOutputMode = { 8, rshmc8015_rngDigitalOutputModeEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngSensorModeEntries[2] =
  {
    { RSHMC8015_VAL_SENSOR_MODE_SHUNT, "EXTS" },
    { RSHMC8015_VAL_SENSOR_MODE_CLAMP, "CCL" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngSensorMode = { 2, rshmc8015_rngSensorModeEntries };

RsCoreRangeTableRanged rshmc8015_rngShuntResistance = { 1.0e-6, 9.9e7, "" };

RsCoreRangeTableRanged rshmc8015_rngClampRatio = { 1.0e-4, 9.9e1, "V" };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngStatusRegisterOperationEntries[2] =
  {
    { RSHMC8015_VAL_STAT_REG_QUESTIONABLE, "QUES" },
    { RSHMC8015_VAL_STAT_REG_OPERATION, "OPER" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngStatusRegisterOperation = { 2, rshmc8015_rngStatusRegisterOperationEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngStatusRegisterQueryEntries[5] =
  {
    { RSHMC8015_VAL_STAT_REG_QUERY_COND, "COND" },
    { RSHMC8015_VAL_STAT_REG_QUERY_EVENT, "EVEN" },
    { RSHMC8015_VAL_STAT_REG_QUERY_ENABLE, "ENAB" },
    { RSHMC8015_VAL_STAT_REG_QUERY_PTRANSITION, "PTR" },
    { RSHMC8015_VAL_STAT_REG_QUERY_NTRANSITION, "NTR" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngStatusRegisterQuery = { 5, rshmc8015_rngStatusRegisterQueryEntries };

static RsCoreRangeTableDiscreteEntry rshmc8015_rngDeviceEntries[3] =
  {
    { RSHMC8015_VAL_DEVICE_INT, "INT" },
    { RSHMC8015_VAL_DEVICE_EXT, "EXT" },
    { RSHMC8015_VAL_DEVICE_DEF, "DEF" }
  };
RsCoreRangeTableDiscrete rshmc8015_rngDevice = { 3, rshmc8015_rngDeviceEntries };


/*****************************************************************************
 *- Attributes --------------------------------------------------------------*
 *****************************************************************************/

RsCoreAttribute  g_RS_ATTR_RANGE_CHECK =
  {
    RS_ATTR_RANGE_CHECK,
    "Range Check",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_QUERY_INSTRUMENT_STATUS =
  {
    RS_ATTR_QUERY_INSTRUMENT_STATUS,
    "Query Instrument Status",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SIMULATE =
  {
    RS_ATTR_SIMULATE,
    "Simulate",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION =
  {
    RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION,
    "Driver Description",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_PREFIX =
  {
    RS_ATTR_SPECIFIC_DRIVER_PREFIX,
    "Driver Prefix",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR =
  {
    RS_ATTR_SPECIFIC_DRIVER_LOCATOR,
    "Driver Locator",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_VENDOR =
  {
    RS_ATTR_SPECIFIC_DRIVER_VENDOR,
    "Driver Vendor",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_REVISION =
  {
    RS_ATTR_SPECIFIC_DRIVER_REVISION,
    "Driver Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION,
    "Class Specification Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION,
    "Class Specification Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS =
  {
    RS_ATTR_SUPPORTED_INSTRUMENT_MODELS,
    "Supported Instrument Models",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_GROUP_CAPABILITIES =
  {
    RS_ATTR_GROUP_CAPABILITIES,
    "Class Group Capabilities",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_FUNCTION_CAPABILITIES =
  {
    RS_ATTR_FUNCTION_CAPABILITIES,
    "Function Capabilities",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CHANNEL_COUNT =
  {
    RS_ATTR_CHANNEL_COUNT,
    "Channel Count",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_DRIVER_SETUP =
  {
    RS_ATTR_DRIVER_SETUP,
    "Driver Setup",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_MANUFACTURER =
  {
    RS_ATTR_INSTRUMENT_MANUFACTURER,
    "Instrument Manufacturer",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "Rohde&Schwarz",
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_MODEL =
  {
    RS_ATTR_INSTRUMENT_MODEL,
    "Instrument Model",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION =
  {
    RS_ATTR_INSTRUMENT_FIRMWARE_REVISION,
    "Instrument Firmware Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_OPTIONS_LIST =
  {
    RS_ATTR_OPTIONS_LIST,
    "Options List",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_IO_RESOURCE_DESCRIPTOR =
  {
    RS_ATTR_IO_RESOURCE_DESCRIPTOR,
    "Resource Descriptor",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_LOGICAL_NAME =
  {
    RS_ATTR_LOGICAL_NAME,
    "Logical Name",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_PRIMARY_ERROR =
  {
    RS_ATTR_PRIMARY_ERROR,
    "Primary Error",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SECONDARY_ERROR =
  {
    RS_ATTR_SECONDARY_ERROR,
    "Secondary Error",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ERROR_ELABORATION =
  {
    RS_ATTR_ERROR_ELABORATION,
    "Error Elaboration",
    RS_VAL_READ_WRITE,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION,
    "Driver Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION,
    "Driver Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION,
    "Driver Minor Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION =
  {
    RS_ATTR_CLASS_DRIVER_MAJOR_VERSION,
    "Class Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION =
  {
    RS_ATTR_CLASS_DRIVER_MINOR_VERSION,
    "Class Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_MAJOR_VERSION =
  {
    RS_ATTR_ENGINE_MAJOR_VERSION,
    "Engine Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_MINOR_VERSION =
  {
    RS_ATTR_ENGINE_MINOR_VERSION,
    "Engine Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_REVISION =
  {
    RS_ATTR_ENGINE_REVISION,
    "Engine Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "0",
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_OPC_TIMEOUT =
  {
    RS_ATTR_OPC_TIMEOUT,
    "Operation Complete (OPC) Timeout",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_MODE =
  {
    RSHMC8015_ATTR_ACQ_MODE,
    "Acquisition Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngAcquisitionMode, NULL, NULL,
    "CHAN{Channel}:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_ACQ_MODE_DC,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_PLL_SOURCE =
  {
    RSHMC8015_ATTR_ACQ_PLL_SOURCE,
    "Acquisition PLL Source",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngPLLSource, NULL, NULL,
    "CHAN{Channel}:MODE:PLL",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_PLL_SOURCE_VOLTAGE,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_FREQUENCY_FILTER =
  {
    RSHMC8015_ATTR_ACQ_FREQUENCY_FILTER,
    "Acquisition Frequency Filter",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:MODE:FREQ",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_DIGITAL_FILTER =
  {
    RSHMC8015_ATTR_ACQ_DIGITAL_FILTER,
    "Acquisition Digital Filter",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:MODE:DIG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_BWL =
  {
    RSHMC8015_ATTR_ACQ_BWL,
    "Acquisition BWL",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:MODE:ANAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_VOLTAGE_AUTORANGE =
  {
    RSHMC8015_ATTR_ACQ_VOLTAGE_AUTORANGE,
    "Acquisition Voltage Autorange",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:VOLT:RANG:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_VOLTAGE_RANGE =
  {
    RSHMC8015_ATTR_ACQ_VOLTAGE_RANGE,
    "Acquisition Voltage Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &rshmc8015_rngAcquisitionVoltageRange, NULL,
    "CHAN{Channel}:VOLT:RANG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    300.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_VOLTAGE_CREST_FACTOR =
  {
    RSHMC8015_ATTR_ACQ_VOLTAGE_CREST_FACTOR,
    "Acquisition Voltage Crest Factor",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngAcquisitionCrestFactor, NULL, NULL,
    "CHAN{Channel}:VOLT:CFAC",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_CREST_FACTOR_3,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_VOLTAGE_INVERT =
  {
    RSHMC8015_ATTR_ACQ_VOLTAGE_INVERT,
    "Acquisition Voltage Invert",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:VOLT:INV",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_CURRENT_AUTORANGE =
  {
    RSHMC8015_ATTR_ACQ_CURRENT_AUTORANGE,
    "Acquisition Current Autorange",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:CURR:RANG:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_CURRENT_RANGE =
  {
    RSHMC8015_ATTR_ACQ_CURRENT_RANGE,
    "Acquisition Current Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &rshmc8015_rngAcquisitionCurrentRange, NULL,
    "CHAN{Channel}:CURR:RANG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    100.0e-3,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_CURRENT_CREST_FACTOR =
  {
    RSHMC8015_ATTR_ACQ_CURRENT_CREST_FACTOR,
    "Acquisition Current Crest Factor",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngAcquisitionCrestFactor, NULL, NULL,
    "CHAN{Channel}:CURR:CFAC",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_CREST_FACTOR_3,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_CURRENT_INVERT =
  {
    RSHMC8015_ATTR_ACQ_CURRENT_INVERT,
    "Acquisition Current Invert",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:CURR:INV",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_OCP =
  {
    RSHMC8015_ATTR_ACQ_OCP,
    "Acquisition Overcurrent Protection",
    RS_VAL_READ_ONLY,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:CURR:PROT?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ACQ_OCP_RESET =
  {
    RSHMC8015_ATTR_ACQ_OCP_RESET,
    "Acquisition Reset Overcurrent Protection",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "CHAN{Channel}:CURR:PROT:RES",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_MEAS_FUNCTION_LIST_LENGTH =
  {
    RSHMC8015_ATTR_MEAS_FUNCTION_LIST_LENGTH,
    "Function List Length",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "CHAN{Channel}:MEAS:FUNC:COUN?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LIMIT_STATE =
  {
    RSHMC8015_ATTR_LIMIT_STATE,
    "Limit State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:LIM{Limit}",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LIMIT_SOURCE =
  {
    RSHMC8015_ATTR_LIMIT_SOURCE,
    "Limit Source",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngLimitSource, NULL, NULL,
    "CHAN{Channel}:LIM{Limit}:SOUR",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_LIMIT_SOURCE_URMS,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LIMIT_HIGH =
  {
    RSHMC8015_ATTR_LIMIT_HIGH,
    "Limit High",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CHAN{Channel}:LIM{Limit}:HIGH",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LIMIT_LOW =
  {
    RSHMC8015_ATTR_LIMIT_LOW,
    "Limit Low",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CHAN{Channel}:LIM{Limit}:LOW",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    -1.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LIMIT_CHECK_RESULT =
  {
    RSHMC8015_ATTR_LIMIT_CHECK_RESULT,
    "Limit Check Result",
    RS_VAL_READ_ONLY,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:LIM{Limit}:RES?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LIMIT_PERCENT =
  {
    RSHMC8015_ATTR_LIMIT_PERCENT,
    "Limit Percent",
    RS_VAL_READ_ONLY,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CHAN{Channel}:LIM{Limit}:PERC?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_AINPUT_STATE =
  {
    RSHMC8015_ATTR_EXT_AINPUT_STATE,
    "Analog Input State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:AINP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_AOUTPUT_STATE =
  {
    RSHMC8015_ATTR_EXT_AOUTPUT_STATE,
    "Analog Output State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:AOUT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_AOUTPUT_MODE =
  {
    RSHMC8015_ATTR_EXT_AOUTPUT_MODE,
    "Analog Output Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngAnalogOutputMode, NULL, NULL,
    "CHAN{Channel}:AOUT:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_AOUT_MODE_VOLTAGE,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_DINPUT_STATE =
  {
    RSHMC8015_ATTR_EXT_DINPUT_STATE,
    "Digital Input State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:DINP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_DINPUT_MODE =
  {
    RSHMC8015_ATTR_EXT_DINPUT_MODE,
    "Digital Input Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngDigitalInputMode, NULL, NULL,
    "CHAN{Channel}:DINP:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_DINP_MODE_FREQUENCY,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_DINPUT_INVERT =
  {
    RSHMC8015_ATTR_EXT_DINPUT_INVERT,
    "Digital Input Invert",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:DINP:INV",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_DOUTPUT_STATE =
  {
    RSHMC8015_ATTR_EXT_DOUTPUT_STATE,
    "Digital Output State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:DOUT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_DOUTPUT_MODE =
  {
    RSHMC8015_ATTR_EXT_DOUTPUT_MODE,
    "Digital Output Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngDigitalOutputMode, NULL, NULL,
    "CHAN{Channel}:DOUT:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_DOUT_MODE_LIM1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_DOUTPUT_OUTPUT_STATE =
  {
    RSHMC8015_ATTR_EXT_DOUTPUT_OUTPUT_STATE,
    "Output State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:DOUT:OUTP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_DOUTPUT_INVERT =
  {
    RSHMC8015_ATTR_EXT_DOUTPUT_INVERT,
    "Digital Output Invert",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:DOUT:INV",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_SENSOR_STATE =
  {
    RSHMC8015_ATTR_EXT_SENSOR_STATE,
    "Sensor State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CHAN{Channel}:SENS",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_SENSOR_MODE =
  {
    RSHMC8015_ATTR_EXT_SENSOR_MODE,
    "Sensor Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngSensorMode, NULL, NULL,
    "CHAN{Channel}:SENS:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_SENSOR_MODE_SHUNT,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_SENSOR_SHUNT_RESISTANCE =
  {
    RSHMC8015_ATTR_EXT_SENSOR_SHUNT_RESISTANCE,
    "Shunt Resistance",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &rshmc8015_rngShuntResistance, NULL,
    "CHAN{Channel}:SENS:EXTS",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_SENSOR_CLAMP_RATIO =
  {
    RSHMC8015_ATTR_EXT_SENSOR_CLAMP_RATIO,
    "Clamp Ratio",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &rshmc8015_rngClampRatio, NULL,
    "CHAN{Channel}:SENS:CCL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.0e-3,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_EXT_SENSOR_RANGE =
  {
    RSHMC8015_ATTR_EXT_SENSOR_RANGE,
    "Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CHAN{Channel}:SENS:RANG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_MODE =
  {
    RSHMC8015_ATTR_VIEW_MODE,
    "Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngViewMode, NULL, NULL,
    "VIEW",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_VIEW_MODE_NORMAL,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_NORM_ACTIVE_PAGE =
  {
    RSHMC8015_ATTR_VIEW_NORM_ACTIVE_PAGE,
    "Active Page",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &rshmc8015_rngActivePage, NULL,
    "VIEW:NORM",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_NORM_PAGE_SIZE =
  {
    RSHMC8015_ATTR_VIEW_NORM_PAGE_SIZE,
    "Size",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngViewNormalPageSize, NULL, NULL,
    "VIEW:NORM:PAGE{Page}:SIZE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_VIEW_PAGE_SIZE_6,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_NORM_FUNCTION =
  {
    RSHMC8015_ATTR_VIEW_NORM_FUNCTION,
    "Function",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngNormalViewFunction, NULL, NULL,
    "VIEW:NORM:PAGE{Page}:CELL{Cell}:FUNC",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_NORMAL_VIEW_FUNC_EMPTY,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_TRUE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_HARM_SELECT =
  {
    RSHMC8015_ATTR_VIEW_HARM_SELECT,
    "Select",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngHarmonicsView, NULL, NULL,
    "VIEW:HARM:VIEW",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_VIEW_HARM_VIEW_BAR,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_HARM_SOURCE =
  {
    RSHMC8015_ATTR_VIEW_HARM_SOURCE,
    "Source",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngHarmonicsSource, NULL, NULL,
    "VIEW:HARM:SOUR",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_VIEW_HARM_SOURCE_VOLTAGE,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_HARM_NUMBER =
  {
    RSHMC8015_ATTR_VIEW_HARM_NUMBER,
    "Number",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &rshmc8015_rngHarmonicsNumber, NULL,
    "VIEW:HARM:NUMB",
    // Defaults I32, I64, Float, Bool, String
    5,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_HARM_SCALING =
  {
    RSHMC8015_ATTR_VIEW_HARM_SCALING,
    "Scaling",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngHarmonicsScaling, NULL, NULL,
    "VIEW:HARM:SCAL",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_VIEW_HARM_SCALING_ABSOLUTE,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_VIEW_HARM_SUBSET =
  {
    RSHMC8015_ATTR_VIEW_HARM_SUBSET,
    "Subset",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngHarmonicsSubset, NULL, NULL,
    "VIEW:HARM:SUBS",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_VIEW_HARM_SUBSET_EVEN,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_INTEGRATOR_STATE =
  {
    RSHMC8015_ATTR_INTEGRATOR_STATE,
    "Integrator State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "INT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_INTEGRATOR_MODE =
  {
    RSHMC8015_ATTR_INTEGRATOR_MODE,
    "Integrator Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngIntegratorMode, NULL, NULL,
    "INT:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_INTEGRATOR_MODE_MANUAL,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_INTEGRATOR_DURATION =
  {
    RSHMC8015_ATTR_INTEGRATOR_DURATION,
    "Integrator Duration",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &rshmc8015_rngIntegratorDuration, NULL,
    "INT:DUR",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_INTEGRATOR_RESET =
  {
    RSHMC8015_ATTR_INTEGRATOR_RESET,
    "Integrator Reset",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "INT:RES",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_INTEGRATOR_START =
  {
    RSHMC8015_ATTR_INTEGRATOR_START,
    "Integrator Start",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "INT:STAR",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_INTEGRATOR_STOP =
  {
    RSHMC8015_ATTR_INTEGRATOR_STOP,
    "Integrator Stop",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "INT:STOP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LOGGING_STATE =
  {
    RSHMC8015_ATTR_LOGGING_STATE,
    "Logging State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "LOG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LOGGING_PAGE =
  {
    RSHMC8015_ATTR_LOGGING_PAGE,
    "Logging Page",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "LOG:PAGE",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LOGGING_MODE =
  {
    RSHMC8015_ATTR_LOGGING_MODE,
    "Logging Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngLoggingMode, NULL, NULL,
    "LOG:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_LOGGING_MODE_UNLIMITED,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LOGGING_TIME =
  {
    RSHMC8015_ATTR_LOGGING_TIME,
    "Logging Time",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &rshmc8015_rngLoggingTime, NULL,
    "LOG:DUR",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_LOGGING_COUNT =
  {
    RSHMC8015_ATTR_LOGGING_COUNT,
    "Logging Count",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &rshmc8015_rngLoggingCount, NULL,
    "LOG:COUN",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_ID_QUERY_RESPONSE =
  {
    RSHMC8015_ATTR_ID_QUERY_RESPONSE,
    "ID Query Response",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "*IDN?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "Rohde&Schwarz,HMC8015,012345678,00.011",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS =
  {
    RSHMC8015_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS,
    "Process All Previous Commands",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "*WAI",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_DISPLAY_CLEAR =
  {
    RSHMC8015_ATTR_DISPLAY_CLEAR,
    "Clear",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "DISP:TEXT:CLE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_DISPLAY_TEXT =
  {
    RSHMC8015_ATTR_DISPLAY_TEXT,
    "Text",
    RS_VAL_WRITE_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "DISP:TEXT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "message",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_HCOPY_IMAGE_FORMAT =
  {
    RSHMC8015_ATTR_HCOPY_IMAGE_FORMAT,
    "Image Format",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc8015_rngImageFormat, NULL, NULL,
    "HCOP:FORM",
    // Defaults I32, I64, Float, Bool, String
    RSHMC8015_VAL_IMAGE_FORMAT_BMP,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_HCOPY_IMAGE_WIDTH =
  {
    RSHMC8015_ATTR_HCOPY_IMAGE_WIDTH,
    "Image Width",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "HCOP:SIZE:X?",
    // Defaults I32, I64, Float, Bool, String
    1920,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_HCOPY_IMAGE_HEIGHT =
  {
    RSHMC8015_ATTR_HCOPY_IMAGE_HEIGHT,
    "Image Height",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "HCOP:SIZE:Y?",
    // Defaults I32, I64, Float, Bool, String
    1080,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_BEEPER_ENABLED =
  {
    RSHMC8015_ATTR_SYSTEM_BEEPER_ENABLED,
    "Beeper Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SYST:BEEP:STAT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_START_BEEP =
  {
    RSHMC8015_ATTR_SYSTEM_START_BEEP,
    "Start Beep",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:BEEP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_NAME =
  {
    RSHMC8015_ATTR_SYSTEM_NAME,
    "System Name",
    RS_VAL_READ_WRITE,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:NAME",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "HMC 8015",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_ERROR =
  {
    RSHMC8015_ATTR_SYSTEM_ERROR,
    "System Error",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:ERR?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_LOCAL =
  {
    RSHMC8015_ATTR_SYSTEM_LOCAL,
    "System Local",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:LOC",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_REMOTE =
  {
    RSHMC8015_ATTR_SYSTEM_REMOTE,
    "System Remote",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:REM",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_RWLOCK =
  {
    RSHMC8015_ATTR_SYSTEM_RWLOCK,
    "System RWLock",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:RWL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_VERSION =
  {
    RSHMC8015_ATTR_SYSTEM_VERSION,
    "System Version",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:VERS?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_DEVICE =
  {
    RSHMC8015_ATTR_SYSTEM_DEVICE,
    "System Device",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:DEV?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_SHUTDOWN =
  {
    RSHMC8015_ATTR_SYSTEM_SHUTDOWN,
    "System Shutdown",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:SHUT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_SOFTWARE =
  {
    RSHMC8015_ATTR_SYSTEM_SOFTWARE,
    "System Software",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:SOFT?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_HARDWARE =
  {
    RSHMC8015_ATTR_SYSTEM_HARDWARE,
    "System Hardware",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:HARD?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_SYSTEM_SERIAL_NUMBER =
  {
    RSHMC8015_ATTR_SYSTEM_SERIAL_NUMBER,
    "System Serial Number",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:SNUM?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC8015_ATTR_STATUS_PRESET =
  {
    RSHMC8015_ATTR_STATUS_PRESET,
    "Status Preset",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "STAT:PRES",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };


/*****************************************************************************
 *- Attributes List ---------------------------------------------------------*
 *****************************************************************************/

ViInt32 rshmc8015_RsCoreAttributeListLength = 111;

RsCoreAttributePtr rshmc8015_RsCoreAttributeList[111] =
  {
    &g_RS_ATTR_RANGE_CHECK,
    &g_RS_ATTR_QUERY_INSTRUMENT_STATUS,
    &g_RS_ATTR_SIMULATE,
    &g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION,
    &g_RS_ATTR_SPECIFIC_DRIVER_PREFIX,
    &g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR,
    &g_RS_ATTR_SPECIFIC_DRIVER_VENDOR,
    &g_RS_ATTR_SPECIFIC_DRIVER_REVISION,
    &g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION,
    &g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS,
    &g_RS_ATTR_GROUP_CAPABILITIES,
    &g_RS_ATTR_FUNCTION_CAPABILITIES,
    &g_RS_ATTR_CHANNEL_COUNT,
    &g_RS_ATTR_DRIVER_SETUP,
    &g_RS_ATTR_INSTRUMENT_MANUFACTURER,
    &g_RS_ATTR_INSTRUMENT_MODEL,
    &g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION,
    &g_RS_ATTR_OPTIONS_LIST,
    &g_RS_ATTR_IO_RESOURCE_DESCRIPTOR,
    &g_RS_ATTR_LOGICAL_NAME,
    &g_RS_ATTR_PRIMARY_ERROR,
    &g_RS_ATTR_SECONDARY_ERROR,
    &g_RS_ATTR_ERROR_ELABORATION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION,
    &g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION,
    &g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION,
    &g_RS_ATTR_ENGINE_MAJOR_VERSION,
    &g_RS_ATTR_ENGINE_MINOR_VERSION,
    &g_RS_ATTR_ENGINE_REVISION,
    &g_RS_ATTR_OPC_TIMEOUT,
    &g_RSHMC8015_ATTR_ACQ_MODE,
    &g_RSHMC8015_ATTR_ACQ_PLL_SOURCE,
    &g_RSHMC8015_ATTR_ACQ_FREQUENCY_FILTER,
    &g_RSHMC8015_ATTR_ACQ_DIGITAL_FILTER,
    &g_RSHMC8015_ATTR_ACQ_BWL,
    &g_RSHMC8015_ATTR_ACQ_VOLTAGE_AUTORANGE,
    &g_RSHMC8015_ATTR_ACQ_VOLTAGE_RANGE,
    &g_RSHMC8015_ATTR_ACQ_VOLTAGE_CREST_FACTOR,
    &g_RSHMC8015_ATTR_ACQ_VOLTAGE_INVERT,
    &g_RSHMC8015_ATTR_ACQ_CURRENT_AUTORANGE,
    &g_RSHMC8015_ATTR_ACQ_CURRENT_RANGE,
    &g_RSHMC8015_ATTR_ACQ_CURRENT_CREST_FACTOR,
    &g_RSHMC8015_ATTR_ACQ_CURRENT_INVERT,
    &g_RSHMC8015_ATTR_ACQ_OCP,
    &g_RSHMC8015_ATTR_ACQ_OCP_RESET,
    &g_RSHMC8015_ATTR_MEAS_FUNCTION_LIST_LENGTH,
    &g_RSHMC8015_ATTR_LIMIT_STATE,
    &g_RSHMC8015_ATTR_LIMIT_SOURCE,
    &g_RSHMC8015_ATTR_LIMIT_HIGH,
    &g_RSHMC8015_ATTR_LIMIT_LOW,
    &g_RSHMC8015_ATTR_LIMIT_CHECK_RESULT,
    &g_RSHMC8015_ATTR_LIMIT_PERCENT,
    &g_RSHMC8015_ATTR_EXT_AINPUT_STATE,
    &g_RSHMC8015_ATTR_EXT_AOUTPUT_STATE,
    &g_RSHMC8015_ATTR_EXT_AOUTPUT_MODE,
    &g_RSHMC8015_ATTR_EXT_DINPUT_STATE,
    &g_RSHMC8015_ATTR_EXT_DINPUT_MODE,
    &g_RSHMC8015_ATTR_EXT_DINPUT_INVERT,
    &g_RSHMC8015_ATTR_EXT_DOUTPUT_STATE,
    &g_RSHMC8015_ATTR_EXT_DOUTPUT_MODE,
    &g_RSHMC8015_ATTR_EXT_DOUTPUT_OUTPUT_STATE,
    &g_RSHMC8015_ATTR_EXT_DOUTPUT_INVERT,
    &g_RSHMC8015_ATTR_EXT_SENSOR_STATE,
    &g_RSHMC8015_ATTR_EXT_SENSOR_MODE,
    &g_RSHMC8015_ATTR_EXT_SENSOR_SHUNT_RESISTANCE,
    &g_RSHMC8015_ATTR_EXT_SENSOR_CLAMP_RATIO,
    &g_RSHMC8015_ATTR_EXT_SENSOR_RANGE,
    &g_RSHMC8015_ATTR_VIEW_MODE,
    &g_RSHMC8015_ATTR_VIEW_NORM_ACTIVE_PAGE,
    &g_RSHMC8015_ATTR_VIEW_NORM_PAGE_SIZE,
    &g_RSHMC8015_ATTR_VIEW_NORM_FUNCTION,
    &g_RSHMC8015_ATTR_VIEW_HARM_SELECT,
    &g_RSHMC8015_ATTR_VIEW_HARM_SOURCE,
    &g_RSHMC8015_ATTR_VIEW_HARM_NUMBER,
    &g_RSHMC8015_ATTR_VIEW_HARM_SCALING,
    &g_RSHMC8015_ATTR_VIEW_HARM_SUBSET,
    &g_RSHMC8015_ATTR_INTEGRATOR_STATE,
    &g_RSHMC8015_ATTR_INTEGRATOR_MODE,
    &g_RSHMC8015_ATTR_INTEGRATOR_DURATION,
    &g_RSHMC8015_ATTR_INTEGRATOR_RESET,
    &g_RSHMC8015_ATTR_INTEGRATOR_START,
    &g_RSHMC8015_ATTR_INTEGRATOR_STOP,
    &g_RSHMC8015_ATTR_LOGGING_STATE,
    &g_RSHMC8015_ATTR_LOGGING_PAGE,
    &g_RSHMC8015_ATTR_LOGGING_MODE,
    &g_RSHMC8015_ATTR_LOGGING_TIME,
    &g_RSHMC8015_ATTR_LOGGING_COUNT,
    &g_RSHMC8015_ATTR_ID_QUERY_RESPONSE,
    &g_RSHMC8015_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS,
    &g_RSHMC8015_ATTR_DISPLAY_CLEAR,
    &g_RSHMC8015_ATTR_DISPLAY_TEXT,
    &g_RSHMC8015_ATTR_HCOPY_IMAGE_FORMAT,
    &g_RSHMC8015_ATTR_HCOPY_IMAGE_WIDTH,
    &g_RSHMC8015_ATTR_HCOPY_IMAGE_HEIGHT,
    &g_RSHMC8015_ATTR_SYSTEM_BEEPER_ENABLED,
    &g_RSHMC8015_ATTR_SYSTEM_START_BEEP,
    &g_RSHMC8015_ATTR_SYSTEM_NAME,
    &g_RSHMC8015_ATTR_SYSTEM_ERROR,
    &g_RSHMC8015_ATTR_SYSTEM_LOCAL,
    &g_RSHMC8015_ATTR_SYSTEM_REMOTE,
    &g_RSHMC8015_ATTR_SYSTEM_RWLOCK,
    &g_RSHMC8015_ATTR_SYSTEM_VERSION,
    &g_RSHMC8015_ATTR_SYSTEM_DEVICE,
    &g_RSHMC8015_ATTR_SYSTEM_SHUTDOWN,
    &g_RSHMC8015_ATTR_SYSTEM_SOFTWARE,
    &g_RSHMC8015_ATTR_SYSTEM_HARDWARE,
    &g_RSHMC8015_ATTR_SYSTEM_SERIAL_NUMBER,
    &g_RSHMC8015_ATTR_STATUS_PRESET
  };
