/*****************************************************************************
 *  Rohde&Schwarz Instrument Driver Specific Attribute callbacks include file
 *
 *  WARNING: Do not add to, delete from, or otherwise modify the contents
 *           of this include file. It is generated from DrBase repository.
 *
 *  Built on: 2024-06-13 13:23:25Z
 *****************************************************************************/

#ifndef __RSHMC8015_ATTRIBUTES_HEADER
#define __RSHMC8015_ATTRIBUTES_HEADER

#include "rscore.h"

#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

/*****************************************************************************
 *- Read Callbacks ----------------------------------------------------------*
 *****************************************************************************/

/*****************************************************************************
 *- Write Callbacks ---------------------------------------------------------*
 *****************************************************************************/

/*****************************************************************************
 *- Range Tables ------------------------------------------------------------*
 *****************************************************************************/
extern RsCoreRangeTableDiscrete rshmc8015_rngViewMode;
extern RsCoreRangeTableDiscrete rshmc8015_rngNormalViewFunction;
extern RsCoreRangeTableDiscrete rshmc8015_rngViewNormalPageSize;
extern RsCoreRangeTableDiscrete rshmc8015_rngHarmonicsView;
extern RsCoreRangeTableDiscrete rshmc8015_rngHarmonicsSource;
extern RsCoreRangeTableRanged rshmc8015_rngHarmonicsNumber;
extern RsCoreRangeTableDiscrete rshmc8015_rngHarmonicsScaling;
extern RsCoreRangeTableDiscrete rshmc8015_rngHarmonicsSubset;
extern RsCoreRangeTableRanged rshmc8015_rngActivePage;
extern RsCoreRangeTableDiscrete rshmc8015_rngIntegratorMode;
extern RsCoreRangeTableRanged rshmc8015_rngIntegratorDuration;
extern RsCoreRangeTableDiscrete rshmc8015_rngLoggingMode;
extern RsCoreRangeTableRanged rshmc8015_rngLoggingTime;
extern RsCoreRangeTableRanged rshmc8015_rngLoggingCount;
extern RsCoreRangeTableDiscrete rshmc8015_rngLimitSource;
extern RsCoreRangeTableDiscrete rshmc8015_rngAcquisitionMode;
extern RsCoreRangeTableRanged rshmc8015_rngAcquisitionVoltageRange;
extern RsCoreRangeTableDiscrete rshmc8015_rngAcquisitionCrestFactor;
extern RsCoreRangeTableRanged rshmc8015_rngAcquisitionCurrentRange;
extern RsCoreRangeTableDiscrete rshmc8015_rngPLLSource;
extern RsCoreRangeTableDiscrete rshmc8015_rngImageFormat;
extern RsCoreRangeTableDiscrete rshmc8015_rngAnalogOutputMode;
extern RsCoreRangeTableDiscrete rshmc8015_rngDigitalInputMode;
extern RsCoreRangeTableDiscrete rshmc8015_rngDigitalOutputMode;
extern RsCoreRangeTableDiscrete rshmc8015_rngSensorMode;
extern RsCoreRangeTableRanged rshmc8015_rngShuntResistance;
extern RsCoreRangeTableRanged rshmc8015_rngClampRatio;
extern RsCoreRangeTableDiscrete rshmc8015_rngStatusRegisterOperation;
extern RsCoreRangeTableDiscrete rshmc8015_rngStatusRegisterQuery;
extern RsCoreRangeTableDiscrete rshmc8015_rngDevice;

/*****************************************************************************
 *- Attributes --------------------------------------------------------------*
 *****************************************************************************/
extern RsCoreAttribute g_RS_ATTR_RANGE_CHECK;
extern RsCoreAttribute g_RS_ATTR_QUERY_INSTRUMENT_STATUS;
extern RsCoreAttribute g_RS_ATTR_SIMULATE;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_PREFIX;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_VENDOR;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_REVISION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS;
extern RsCoreAttribute g_RS_ATTR_GROUP_CAPABILITIES;
extern RsCoreAttribute g_RS_ATTR_FUNCTION_CAPABILITIES;
extern RsCoreAttribute g_RS_ATTR_CHANNEL_COUNT;
extern RsCoreAttribute g_RS_ATTR_DRIVER_SETUP;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_MANUFACTURER;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_MODEL;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION;
extern RsCoreAttribute g_RS_ATTR_OPTIONS_LIST;
extern RsCoreAttribute g_RS_ATTR_IO_RESOURCE_DESCRIPTOR;
extern RsCoreAttribute g_RS_ATTR_LOGICAL_NAME;
extern RsCoreAttribute g_RS_ATTR_PRIMARY_ERROR;
extern RsCoreAttribute g_RS_ATTR_SECONDARY_ERROR;
extern RsCoreAttribute g_RS_ATTR_ERROR_ELABORATION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_REVISION;
extern RsCoreAttribute g_RS_ATTR_OPC_TIMEOUT;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_MODE;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_PLL_SOURCE;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_FREQUENCY_FILTER;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_DIGITAL_FILTER;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_BWL;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_VOLTAGE_AUTORANGE;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_VOLTAGE_RANGE;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_VOLTAGE_CREST_FACTOR;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_VOLTAGE_INVERT;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_CURRENT_AUTORANGE;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_CURRENT_RANGE;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_CURRENT_CREST_FACTOR;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_CURRENT_INVERT;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_OCP;
extern RsCoreAttribute g_RSHMC8015_ATTR_ACQ_OCP_RESET;
extern RsCoreAttribute g_RSHMC8015_ATTR_MEAS_FUNCTION_LIST_LENGTH;
extern RsCoreAttribute g_RSHMC8015_ATTR_LIMIT_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_LIMIT_SOURCE;
extern RsCoreAttribute g_RSHMC8015_ATTR_LIMIT_HIGH;
extern RsCoreAttribute g_RSHMC8015_ATTR_LIMIT_LOW;
extern RsCoreAttribute g_RSHMC8015_ATTR_LIMIT_CHECK_RESULT;
extern RsCoreAttribute g_RSHMC8015_ATTR_LIMIT_PERCENT;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_AINPUT_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_AOUTPUT_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_AOUTPUT_MODE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_DINPUT_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_DINPUT_MODE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_DINPUT_INVERT;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_DOUTPUT_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_DOUTPUT_MODE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_DOUTPUT_OUTPUT_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_DOUTPUT_INVERT;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_SENSOR_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_SENSOR_MODE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_SENSOR_SHUNT_RESISTANCE;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_SENSOR_CLAMP_RATIO;
extern RsCoreAttribute g_RSHMC8015_ATTR_EXT_SENSOR_RANGE;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_MODE;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_NORM_ACTIVE_PAGE;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_NORM_PAGE_SIZE;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_NORM_FUNCTION;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_HARM_SELECT;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_HARM_SOURCE;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_HARM_NUMBER;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_HARM_SCALING;
extern RsCoreAttribute g_RSHMC8015_ATTR_VIEW_HARM_SUBSET;
extern RsCoreAttribute g_RSHMC8015_ATTR_INTEGRATOR_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_INTEGRATOR_MODE;
extern RsCoreAttribute g_RSHMC8015_ATTR_INTEGRATOR_DURATION;
extern RsCoreAttribute g_RSHMC8015_ATTR_INTEGRATOR_RESET;
extern RsCoreAttribute g_RSHMC8015_ATTR_INTEGRATOR_START;
extern RsCoreAttribute g_RSHMC8015_ATTR_INTEGRATOR_STOP;
extern RsCoreAttribute g_RSHMC8015_ATTR_LOGGING_STATE;
extern RsCoreAttribute g_RSHMC8015_ATTR_LOGGING_PAGE;
extern RsCoreAttribute g_RSHMC8015_ATTR_LOGGING_MODE;
extern RsCoreAttribute g_RSHMC8015_ATTR_LOGGING_TIME;
extern RsCoreAttribute g_RSHMC8015_ATTR_LOGGING_COUNT;
extern RsCoreAttribute g_RSHMC8015_ATTR_ID_QUERY_RESPONSE;
extern RsCoreAttribute g_RSHMC8015_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS;
extern RsCoreAttribute g_RSHMC8015_ATTR_DISPLAY_CLEAR;
extern RsCoreAttribute g_RSHMC8015_ATTR_DISPLAY_TEXT;
extern RsCoreAttribute g_RSHMC8015_ATTR_HCOPY_IMAGE_FORMAT;
extern RsCoreAttribute g_RSHMC8015_ATTR_HCOPY_IMAGE_WIDTH;
extern RsCoreAttribute g_RSHMC8015_ATTR_HCOPY_IMAGE_HEIGHT;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_BEEPER_ENABLED;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_START_BEEP;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_NAME;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_ERROR;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_LOCAL;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_REMOTE;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_RWLOCK;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_VERSION;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_DEVICE;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_SHUTDOWN;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_SOFTWARE;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_HARDWARE;
extern RsCoreAttribute g_RSHMC8015_ATTR_SYSTEM_SERIAL_NUMBER;
extern RsCoreAttribute g_RSHMC8015_ATTR_STATUS_PRESET;

/*****************************************************************************
 *- Repeated Capabilities Table ---------------------------------------------*
 *****************************************************************************/
extern RsCoreRepCap rshmc8015_RsCoreRepCapTable[];
extern ViInt32 rshmc8015_RsCoreRepCapTableCount;

/*****************************************************************************
 *- Attributes List ---------------------------------------------------------*
 *****************************************************************************/
extern RsCoreAttributePtr rshmc8015_RsCoreAttributeList[];
extern ViInt32 rshmc8015_RsCoreAttributeListLength;

/****************************************************************************
 *---------------------------- End Include File ----------------------------*
 ****************************************************************************/
#if defined(__cplusplus) || defined(__cplusplus__)
}
#endif
#endif /* __RSHMC8015_ATTRIBUTES_HEADER */
